

----
--
----
----missione creata da PVI-Eagle---------------------------------
--

  
------------------------------------------------------------------------------------------------------------------------------------  
-----------------------
--- WAREHOUSE class.

-- Display mission time every 30 seconds.
SCHEDULER:New(nil, UTILS.DisplayMissionTime, {5}, 30, 30)
BASE:E(" --- START WAREHOUSE MISSION ---")

BASE:TraceClass("WAREHOUSE")
BASE:TraceOnOff(true)

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Define Warehouses.
local warehouse={}




--Base avanzata BLU  Portaelicotteri
warehouse.Base_Avanzata_BLU   = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Avanzata_BLU"),   "Base_Avanzata_BLU")   --Functional.Warehouse#WAREHOUSE
--warehouse.Base_Avanzata_BLU:SetSpawnZone(ZONE:New("Base_Avanzata_BLU Spawn Zone"))
warehouse.Base_Avanzata_BLU:Start()
warehouse.Base_Avanzata_BLU:SetReportOff()
warehouse.Base_Avanzata_BLU:AddAsset("AAV7", 10)
warehouse.Base_Avanzata_BLU:AddAsset("LAV-25", 10)
warehouse.Base_Avanzata_BLU:AddAsset("Infantry", 10)
warehouse.Base_Avanzata_BLU:AddAsset("MLRS", 10)
warehouse.Base_Avanzata_BLU:AddAsset("UH-1H", 20, WAREHOUSE.Attribute.AIR_TRANSPORTHELO)
warehouse.Base_Avanzata_BLU:AddAsset("AW-1W", 20, WAREHOUSE.Attribute.AIR_ATTACKHELO)
warehouse.Base_Avanzata_BLU:__Pause(5)--pausa dopo 5 secondi

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--Base avanzata ROSSI   BANDAR ABBAS AIRPORT
warehouse.Base_Avanzata_ROSSI = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Avanzata_ROSSI"), "Base_Avanzata_ROSSI") --Functional.Warehouse#WAREHOUSE
warehouse.Base_Avanzata_ROSSI:SetSpawnZone(ZONE:New("Base_Avanzata_ROSSI Spawn Zone"))
warehouse.Base_Avanzata_ROSSI:Start()
warehouse.Base_Avanzata_ROSSI:SetReportOff()
warehouse.Base_Avanzata_ROSSI:AddAsset("BRDM2", 10)
warehouse.Base_Avanzata_ROSSI:AddAsset("BTR-80", 10)
warehouse.Base_Avanzata_ROSSI:AddAsset("M113", 10)
warehouse.Base_Avanzata_ROSSI:AddAsset("Infantry Iran", 10)
warehouse.Base_Avanzata_ROSSI:AddAsset("Mi-8", 20, WAREHOUSE.Attribute.AIR_TRANSPORTHELO)
warehouse.Base_Avanzata_ROSSI:AddAsset("BMP-1", 20)
warehouse.Base_Avanzata_ROSSI:AddAsset("T-72", 20)
warehouse.Base_Avanzata_ROSSI:AddRequest(warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_INFANTRY, 1, nil, nil, nil, nil) 
warehouse.Base_Avanzata_ROSSI:AddRequest(warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, nil) 
warehouse.Base_Avanzata_ROSSI:__Pause(40)--pausa dopo 40 secondi

--Base rifornimenti ROSSI   BANDAR ABBAS AIRPORT
warehouse.Base_Rifornimenti_ROSSI = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Rifornimenti_ROSSI"), "Base_Rifornimenti_ROSSI") --Functional.Warehouse#WAREHOUSE
warehouse.Base_Rifornimenti_ROSSI:SetSpawnZone(ZONE:New("Base_Rifornimenti_ROSSI Spawn Zone"))
warehouse.Base_Rifornimenti_ROSSI:Start()
warehouse.Base_Rifornimenti_ROSSI:SetReportOff()
warehouse.Base_Rifornimenti_ROSSI:AddAsset("BRDM2", 10)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("Transport", 40)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("M113", 10)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("Infantry Iran", 40)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("Mi-8", 20, WAREHOUSE.Attribute.AIR_TRANSPORTHELO)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("BMP-1", 20)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("T-72", 20)
warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_INFANTRY, 1, nil, nil, nil, nil) 
warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TRUCK, 1, nil, nil, nil, nil) 
warehouse.Base_Rifornimenti_ROSSI:__Pause(40)--pausa dopo 40 secondi
-------------------------------------------------------------------------------------FLAGS --------------------------------------------------------------------------------------------------------------------

-- se il flag  attivo unpause dopo 1 secondo  
warehouse_SCHEDULER = SCHEDULER:New(nil,
  function()
 if ( trigger.misc.getUserFlag(119) == 1 ) then 
 warehouse.Base_Avanzata_ROSSI:__Unpause(40)
 warehouse.Base_Avanzata_BLU:__Unpause(40) 
 warehouse.Base_Rifornimenti_ROSSI:__Unpause(40)
-- controlla se i targets del file AN Markpoints sono stati distrutti e leva i markpoints  

--elseif( trigger.misc.getUserFlag(541) == 1 ) then
--        RemoveMark( "T06" ) -- The mark is now removed
 
--elseif( trigger.misc.getUserFlag(544) == 1 ) then
--        RemoveMark( "T07" ) -- The mark is now removed
 
 end 
  end, 
{}, 5, 10, 0 )



 
--------------------------------------------RICHIESTA DA PARTE DI Base_Rifornimenti_ROSSI CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
--
---- Battle zone . This is where the action is!
local BattleZone=ZONE:New("PALAZZO DEL GOVERNATORE") 
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10

  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_INFANTRY, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TRUCK, 1, nil, nil, nil, "To Battle Zone")

end

 
-- Take care of the spawned units.
function warehouse.Base_Rifornimenti_ROSSI:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Rifornimenti_ROSSI:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
  end
end

-- An asset has died ==> request resupply for it.
function warehouse.Base_Rifornimenti_ROSSI:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  -- Get assignment.
  local assignment=warehouse.Base_Rifornimenti_ROSSI:GetAssignment(request)  
end




--------------------------------------------RICHIESTA DA PARTE DI Base_Avanzata_ROSSI CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
--
---- Battle zone . This is where the action is!
local BattleZone=ZONE:New("BATTLEZONE") 
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10
  warehouse.Base_Avanzata_ROSSI:__AddRequest(time, warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.AIR_TRANSPORTHELO, 1, nil, nil, nil, "BAI") 
  warehouse.Base_Avanzata_ROSSI:__AddRequest(time, warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Avanzata_ROSSI:__AddRequest(time, warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To Battle Zone")
  warehouse.Base_Avanzata_ROSSI:__AddRequest(time, warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.GROUPNAME,"M113", 1, nil, nil, nil, "To Battle Zone") 
end

 
-- Take care of the spawned units.
function warehouse.Base_Avanzata_ROSSI:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Avanzata_ROSSI:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
  elseif assignment=="BAI" then
      
      -- Start uncontrolled helo.
        local group=groupset:GetFirst() --Wrapper.Group#GROUP
       group:StartUncontrolled()
       
       local BAIEngagementZone = ZONE:New( "porto" )
       
       local BAI=AI_BAI_ZONE:New(ZONE:New("stazione"), 500, 1000, 500, 600, BAIEngagementZone)
        
    
         -- Tell the program to use the object (in this case called BAIPlane) as the group to use in the BAI function
           BAI:SetControllable(group)
          
                     
           -- Start BAI
           BAI:Start()
           
           -- Engage after 1 minuto.
           BAI:__Engage(60)
          
          -- RTB after 30 min max.
           BAI:__RTB(18000)  
           
      end
  end

-- An asset has died ==> request resupply for it.
function warehouse.Base_Avanzata_ROSSI:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  -- Get assignment.
  local assignment=warehouse.Base_Avanzata_ROSSI:GetAssignment(request)  
end

------------------------------------------------------------------B  L  U------------------------------------------------------------------------------------
--
--
--
--------------------------------------------RICHIESTA DA PARTE DI Base_Avanzata_BLU CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
------ Battle zone . This is where the action is!
--local BattleZone=ZONE:New("BATTLEZONE")
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10

   warehouse.Base_Avanzata_BLU:__AddRequest(time, warehouse.Base_Avanzata_BLU,  WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.AIR_TRANSPORTHELO, 1, nil, nil, nil, "BAI1")
   warehouse.Base_Avanzata_BLU:__AddRequest(time, warehouse.Base_Avanzata_BLU,  WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.AIR_ATTACKHELO, 1, nil, nil, nil, "BAI2")
end

 
-- Take care of the spawned units.
function warehouse.Base_Avanzata_BLU:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Avanzata_BLU:GetAssignment(request)
  
  if assignment=="BAI1" then
    
      -- Start uncontrolled helo.
        local group=groupset:GetFirst() --Wrapper.Group#GROUP
       group:StartUncontrolled()
       
       local BAIEngagementZone = ZONE:New( "porto" )
       
       local BAI=AI_BAI_ZONE:New(ZONE:New("stazione"), 500, 1000, 500, 600, BAIEngagementZone)
        
    
         -- Tell the program to use the object (in this case called BAIPlane) as the group to use in the BAI function
           BAI:SetControllable(group)
          
                     
           -- Start BAI
           BAI:Start()
           
           -- Engage after 1 minuto.
           BAI:__Engage(60)
          
          -- RTB after 30 min max.
           BAI:__RTB(18000)  


  elseif assignment=="BAI2" then
    
        
      -- Start uncontrolled helo.
        local group=groupset:GetFirst() --Wrapper.Group#GROUP
       group:StartUncontrolled()
       
       local BAIEngagementZone = ZONE:New( "BATTLEZONE" )
       
       local BAI=AI_BAI_ZONE:New(ZONE:New("bighangar"), 500, 1000, 500, 600, BAIEngagementZone)
        
    
         -- Tell the program to use the object (in this case called BAIPlane) as the group to use in the BAI function
           BAI:SetControllable(group)
          
                     
           -- Start BAI
           BAI:Start()
           
           -- Engage after 1 minuto.
           BAI:__Engage(60)
          
          -- RTB after 30 min max.
           BAI:__RTB(18000)  
           
      end
  end

-- An asset has died ==> request resupply for it.
function warehouse.Base_Avanzata_BLU:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment.
  local assignment=warehouse.Base_Avanzata_BLU:GetAssignment(request)

  -- Request resupply for dead asset from Base_Rifornimenti_BLU.
  --warehouse.Base_Rifornimenti_BLU:AddRequest(warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, WAREHOUSE.Quantity.ALL, WAREHOUSE.TransportType.AIRPLANE, nil, nil, "Resupply") 
  warehouse.Base_Avanzata_BLU:AddRequest(warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply")
  
  -- Send asset to Battle zone either now or when they arrive.
  warehouse.Base_Avanzata_BLU:AddRequest(warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, assignment)
end



------------------------------------------------------MESSAGGIO IN CASO DISTRUZIONE WAREHOUSE Base_Avanzata_ROSSI--------------------------------------------------------

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.
function warehouse.Base_Avanzata_ROSSI:onafterDestroyed(From, Event, To)

  -- Message.
  local text=string.format("Warehouse %s was destroyed! Assets lost %d.", self.alias, #self.stock)
  self:_InfoMessage(text)
  
  -- Remove all table entries from waiting queue and stock.
  for k,_ in pairs(self.queue) do
    self.queue[k]=nil
  end
  for k,_ in pairs(self.stock) do
    self.stock[k]=nil
  end

  --self.queue=nil
  --self.queue={}

  --self.stock=nil
  --self.stock={}
  

  
end
