----------------------
--missione creata da PVI-Eagle--  
-----------------------------------------CARGO-----------------------------------------------------
---
-- Name: TAD-CGO-000 - CSAR Test
-- Author: FlightControl
-- Date Created: 31 Mar 2018
--
-- # Situation:
-- 
-- This mission demonstrates the dynamic task dispatching for cargo CSAR operations.
-- 

 do -- Setup the Command Centers
HQ = GROUP:FindByName( "HQ" )

CommandCenter = COMMANDCENTER
  :New( HQ, "COMANDO ELICOTTERI" )
end


do -- Missions
Mission = MISSION
  :New( CommandCenter, "CSAR Missions", "Tactical", "Rescue downed pilots.", coalition.side.BLUE )

AttackGroups = SET_GROUP:New():FilterCoalitions( "blue" ):FilterPrefixes( "UH1H" ):FilterStart()

TaskDispatcher = TASK_CARGO_DISPATCHER:New( Mission, AttackGroups )
end

do -- Missions
----INSERTO TRASPORTO TRUPPE 
Rangers = MISSION
    :New( CommandCenter, "Rangers Platoon", "Operational","TRASPORTA i team di Rangers nella zona di combattimento. ", coalition.side.BLUE )
           
            
HeloSetGroup = SET_GROUP:New():FilterPrefixes( "UH1H" ):FilterStart()
SetCargo = SET_CARGO:New():FilterTypes( { "Rangers Platoon" } ):FilterStart()

EngineersCargo1 = CARGO_GROUP:New( GROUP:FindByName( "M4 US Platoon Bear" ), "Rangers Platoon", "Team Bear", 500 )
EngineersCargo2 = CARGO_GROUP:New( GROUP:FindByName( "M4 US Platoon Moose" ), "Rangers Platoon", "Team Moose", 500 )
EngineersCargo3 = CARGO_GROUP:New( GROUP:FindByName( "M4 US Platoon Falcon" ), "Rangers Platoon", "Team Falcon", 500 )
EngineersCargo4 = CARGO_GROUP:New( GROUP:FindByName( "M4 US Platoon Tiger" ), "Rangers Platoon", "Team Tiger", 500 )
EngineersCargo5 = CARGO_GROUP:New( GROUP:FindByName( "M4 US Platoon Wolf" ), "Rangers Platoon", "Team Wolf", 500 )
EngineersCargo6 = CARGO_GROUP:New( GROUP:FindByName( "M4 US Platoon Eagle" ), "Rangers Platoon", "Team Eagle", 500 )
  
CargoTransportTask = TASK_CARGO_TRANSPORT:New( Rangers, HeloSetGroup, "Transport Rangers", SetCargo )

----FINE TRASPORTO TRUPPE
end

do -- Missions
TaskDispatcher:StartCSARTasks( 
  "CSAR", 
 {  ZONE_UNIT:New( "OSPEDALE FARP", STATIC:FindByName( "OSPEDALE FARP" ), 100 ) ,
    ZONE_UNIT:New( "OSPEDALE AVANZATO EST", STATIC:FindByName( "OSPEDALE AVANZATO EST" ), 100 ) ,
    ZONE_UNIT:New( "OSPEDALE AVANZATO OVEST", STATIC:FindByName( "OSPEDALE AVANZATO OVEST" ), 100 ) ,
 } ,

  "Con l'UH1H puoi eseguire missioni SAR e di TRASPORTO TRUPPE!\n" .. 
  "Usa il menu' radio per farti assistere dal centro di comando."
)
end

